stages:
  - test
  # - build
  - image
  - deploy
  - release

start:
  stage: test
  image: node:18
  except: 
    - deploy
    - main
    - 33-public-docker
  script:
   - npm install
   - cp src/config/config.sample.ts src/config/config.ts
   - npm run test
   - npm run build

dockerimage:
  image: docker
  only: 
    - deploy
    - main
    - 33-public-docker
  stage: image
  services:
    - name: docker:24.0.6-dind
      alias: thedockerhost
  variables:
    # Tell docker CLI how to talk to Docker daemon; see
    # https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#use-docker-in-docker-executor
    DOCKER_HOST: tcp://thedockerhost:2375/
    # Use the overlayfs driver for improved performance:
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: ""
    IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_TAG .
    - docker push $IMAGE_TAG

deployimage: 
  stage: deploy
  image: curlimages/curl
  script: curl --fail --request POST --form token=$CI_JOB_TOKEN --form ref=main "$CI_API_V4_URL/projects/$DEPLOY_PROJECT/trigger/pipeline"
  rules:
    - if: $DEPLOY_PROJECT
    - if: $CI_COMMIT_BRANCH == "deploy"

publish:
  image: node:latest
  stage: release
  script:
    - npm i
    - |
      {
        echo "@${CI_PROJECT_ROOT_NAMESPACE}:registry=${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/npm/"
        echo "${CI_API_V4_URL#https?}/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=\${CI_JOB_TOKEN}"
      } | tee -a .npmrc
    - npm run semantic-release
  rules:
    - if: $CI_COMMIT_BRANCH == "deploy"
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH